# coding: utf-8

"""
    Sonarr

    Sonarr API docs - The v3 API docs apply to both v3 and v4 versions of Sonarr. Some functionality may only be available in v4 of the Sonarr application.

    The version of the OpenAPI document: v4.0.1.929
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, Optional
from typing import Optional, Set
from typing_extensions import Self

class NamingConfigResource(BaseModel):
    """
    NamingConfigResource
    """ # noqa: E501
    id: Optional[StrictInt] = None
    rename_episodes: Optional[StrictBool] = Field(default=None, alias="renameEpisodes")
    replace_illegal_characters: Optional[StrictBool] = Field(default=None, alias="replaceIllegalCharacters")
    colon_replacement_format: Optional[StrictInt] = Field(default=None, alias="colonReplacementFormat")
    multi_episode_style: Optional[StrictInt] = Field(default=None, alias="multiEpisodeStyle")
    standard_episode_format: Optional[StrictStr] = Field(default=None, alias="standardEpisodeFormat")
    daily_episode_format: Optional[StrictStr] = Field(default=None, alias="dailyEpisodeFormat")
    anime_episode_format: Optional[StrictStr] = Field(default=None, alias="animeEpisodeFormat")
    series_folder_format: Optional[StrictStr] = Field(default=None, alias="seriesFolderFormat")
    season_folder_format: Optional[StrictStr] = Field(default=None, alias="seasonFolderFormat")
    specials_folder_format: Optional[StrictStr] = Field(default=None, alias="specialsFolderFormat")
    include_series_title: Optional[StrictBool] = Field(default=None, alias="includeSeriesTitle")
    include_episode_title: Optional[StrictBool] = Field(default=None, alias="includeEpisodeTitle")
    include_quality: Optional[StrictBool] = Field(default=None, alias="includeQuality")
    replace_spaces: Optional[StrictBool] = Field(default=None, alias="replaceSpaces")
    separator: Optional[StrictStr] = None
    number_style: Optional[StrictStr] = Field(default=None, alias="numberStyle")
    __properties: ClassVar[List[str]] = ["id", "renameEpisodes", "replaceIllegalCharacters", "colonReplacementFormat", "multiEpisodeStyle", "standardEpisodeFormat", "dailyEpisodeFormat", "animeEpisodeFormat", "seriesFolderFormat", "seasonFolderFormat", "specialsFolderFormat", "includeSeriesTitle", "includeEpisodeTitle", "includeQuality", "replaceSpaces", "separator", "numberStyle"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NamingConfigResource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if standard_episode_format (nullable) is None
        # and model_fields_set contains the field
        if self.standard_episode_format is None and "standard_episode_format" in self.model_fields_set:
            _dict['standardEpisodeFormat'] = None

        # set to None if daily_episode_format (nullable) is None
        # and model_fields_set contains the field
        if self.daily_episode_format is None and "daily_episode_format" in self.model_fields_set:
            _dict['dailyEpisodeFormat'] = None

        # set to None if anime_episode_format (nullable) is None
        # and model_fields_set contains the field
        if self.anime_episode_format is None and "anime_episode_format" in self.model_fields_set:
            _dict['animeEpisodeFormat'] = None

        # set to None if series_folder_format (nullable) is None
        # and model_fields_set contains the field
        if self.series_folder_format is None and "series_folder_format" in self.model_fields_set:
            _dict['seriesFolderFormat'] = None

        # set to None if season_folder_format (nullable) is None
        # and model_fields_set contains the field
        if self.season_folder_format is None and "season_folder_format" in self.model_fields_set:
            _dict['seasonFolderFormat'] = None

        # set to None if specials_folder_format (nullable) is None
        # and model_fields_set contains the field
        if self.specials_folder_format is None and "specials_folder_format" in self.model_fields_set:
            _dict['specialsFolderFormat'] = None

        # set to None if separator (nullable) is None
        # and model_fields_set contains the field
        if self.separator is None and "separator" in self.model_fields_set:
            _dict['separator'] = None

        # set to None if number_style (nullable) is None
        # and model_fields_set contains the field
        if self.number_style is None and "number_style" in self.model_fields_set:
            _dict['numberStyle'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NamingConfigResource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "renameEpisodes": obj.get("renameEpisodes"),
            "replaceIllegalCharacters": obj.get("replaceIllegalCharacters"),
            "colonReplacementFormat": obj.get("colonReplacementFormat"),
            "multiEpisodeStyle": obj.get("multiEpisodeStyle"),
            "standardEpisodeFormat": obj.get("standardEpisodeFormat"),
            "dailyEpisodeFormat": obj.get("dailyEpisodeFormat"),
            "animeEpisodeFormat": obj.get("animeEpisodeFormat"),
            "seriesFolderFormat": obj.get("seriesFolderFormat"),
            "seasonFolderFormat": obj.get("seasonFolderFormat"),
            "specialsFolderFormat": obj.get("specialsFolderFormat"),
            "includeSeriesTitle": obj.get("includeSeriesTitle"),
            "includeEpisodeTitle": obj.get("includeEpisodeTitle"),
            "includeQuality": obj.get("includeQuality"),
            "replaceSpaces": obj.get("replaceSpaces"),
            "separator": obj.get("separator"),
            "numberStyle": obj.get("numberStyle")
        })
        return _obj


